// Specific definitions for generic platforms  -*- C++ -*-

// Copyright (C) 2000-2019 Free Software Foundation, Inc.
//
// This file is part of the GNU ISO C++ Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the
// Free Software Foundation; either version 3, or (at your option)
// any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// Under Section 7 of GPL version 3, you are granted additional
// permissions described in the GCC Runtime Library Exception, version
// 3.1, as published by the Free Software Foundation.

// You should have received a copy of the GNU General Public License and
// a copy of the GCC Runtime Library Exception along with this program;
// see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
// <http://www.gnu.org/licenses/>.

/** @file bits/os_defines.h
 *  This is an internal header file, included by other library headers.
 *  Do not attempt to use it directly. @headername{iosfwd}
 */

#ifndef _GLIBCXX_OS_DEFINES
#define _GLIBCXX_OS_DEFINES 1

// System-specific #define, typedefs, corrections, etc, go here.  This
// file will come before all others.

// Disable the weak reference logic in gthr.h for os/generic because it
// is broken on every platform unless there is implementation specific
// workaround in gthr-posix.h and at link-time for static linking.
#define _GLIBCXX_GTHREAD_USE_WEAK 0

// Use the default behavior in eh_globals.cc for os/generic.
#define _GLIBCXX_AVOID_GLOBAL_INIT_COW 0

// Use the default behavior IEEE 754 divide by zero for os/generic.
#define _GLIBCXX_CHECK_DIVIDE_BY_ZERO 0

// Use the default behavior of standard I/O streams for os/generic.
#define _GLIBCXX_USE_SYSTEM_IO_IMPL 0

// Use the default behavior of abort in vterminate.cc for os/generic.
#define _GLIBCXX_USE_SYSTEM_ABORT_IMPL 0

// Use the default demangling API for os/generic that does not require
// a charset conversion for demangle calls outside of cp-demangle.c.
#define _GLIBCXX_REQUIRE_DEMANGLE_ICONV 0
#define __DEFAULT_CHARSET ""
#define __DEMANGLE_CHARSET ""
#define __DEFAULT_CHARSET_BAD_ALLOC "St9bad_alloc"
#define __DEMANGLE_CHARSET_BAD_ALLOC "St9bad_alloc"

// Prevent gthreads from starting when multithreading is not currently
// active for os/generic because it is not allowed on every platform
// unless they specifically implement such a feature.
#define _GLIBCXX_GTHREAD_ALLOW_NON_ACTIVE_START 0

#endif
