/* Structures and access functions TPF ECB fields
   Copyright (C) 2003 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */


#ifndef _BITS_ECBVARS_H_                                                        //ZTPF11
#define _BITS_ECBVARS_H_ 1                                                      //ZTPF11

#ifdef __cplusplus                                                              //ZTPF11
   extern "C" {                                                                 //ZTPF11
#endif                                                                          //ZTPF11


/* This structure maps ECB page 2 */
struct __tpf_ecb_page2 {                                                        //ZTPF11
   void          *__ce2thrc;       /* Address of thread common block */         //ZTPF11
   void          *__ce2thru;       /* Address of thread unique block */         //ZTPF11
   unsigned char  __ce2thtyp;      /* Thread type indicator */
   unsigned char  __ce2_reserved0[31];                                          //ZTPF11
   unsigned char  __ce2_reserved1[664];                                         //ZTPF11
} __attribute__ ((__packed__));                                                 //PJ45408


/* This macro returns the starting address of ECB page 2 */
#define __tpf_ecb_page2_addr()                                  \
    ((struct __tpf_ecb_page2  *)(*(unsigned long**) (0x00000FB8ul)))            //ZTPF11

#ifdef __cplusplus                                                              //ZTPF11
   }                                                                            //ZTPF11
#endif                                                                          //ZTPF11

#endif                                                                          //ZTPF11

