/* Access functions for TPF thread unique fields
   Copyright (C) 2003 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */


#ifndef _BITS_THRUVARS_H_                                                       //ZTPF11
#define _BITS_THRUVARS_H_ 1                                                     //ZTPF11

#include <bits/ecbvars.h>                                                       //ZTPF11

#ifdef __cplusplus                                                              //ZTPF11
   extern "C" {                                                                 //ZTPF11
#endif                                                                          //ZTPF11


/* The thread unique control block begins with an array of  */
/* pointers.  The pointers contain the addresses of varying */
/* fields.  These are the indices into that array.          */
#define __TPF_ERRNO_ITUCERRI   0                                                //ZTPF11
#define __TPF_OPTIND_ITUCOIND  1                                                //ZTPF11
#define __TPF_OPTARG_ITUCOARG  2                                                //ZTPF11
#define __TPF_OPTOPT_ITUCOOPT  3                                                //ZTPF11
#define __TPF_OPTERR_ITUCOERR  4                                                //ZTPF11


typedef void ** __tpf_thru_fields_t;                                            //ZTPF11

#define __tpf_thread_unique_addr()                  \
             ((__tpf_thru_fields_t)((__tpf_ecb_page2_addr())->__ce2thru))       //ZTPF11


/* This function returns the address of the errno variable */
static inline int *                                                             //ZTPF11
__attribute__ ((__unused__))                                                    //PJ45408
__tpf_errno_location(void)                                                      //ZTPF11
{                                                                               //ZTPF11
   __tpf_thru_fields_t thru;                                                    //ZTPF11

   thru = __tpf_thread_unique_addr();                                           //ZTPF11

   return (int *)(thru[__TPF_ERRNO_ITUCERRI]);                                  //ZTPF11
}                                                                               //ZTPF11


/* This function returns the address of the optarg variable */
static inline char **                                                           //ZTPF11
__attribute__ ((__unused__))                                                    //PJ45408
__tpf_optarg_location(void)                                                     //ZTPF11
{                                                                               //ZTPF11
   __tpf_thru_fields_t thru;                                                    //ZTPF11

   thru = __tpf_thread_unique_addr();                                           //ZTPF11

   return (char **)(thru[__TPF_OPTARG_ITUCOARG]);                               //ZTPF11
}                                                                               //ZTPF11


/* This function returns the address of the optind variable */
static inline int *                                                             //ZTPF11
__attribute__ ((__unused__))                                                    //PJ45408
__tpf_optind_location(void)                                                     //ZTPF11
{                                                                               //ZTPF11
   __tpf_thru_fields_t thru;                                                    //ZTPF11

   thru = __tpf_thread_unique_addr();                                           //ZTPF11

   return (int *)(thru[__TPF_OPTIND_ITUCOIND]);                                 //ZTPF11
}                                                                               //ZTPF11


/* This function returns the address of the optopt variable */
static inline int *                                                             //ZTPF11
__attribute__ ((__unused__))                                                    //PJ45408
__tpf_optopt_location(void)                                                     //ZTPF11
{                                                                               //ZTPF11
   __tpf_thru_fields_t thru;                                                    //ZTPF11

   thru = __tpf_thread_unique_addr();                                           //ZTPF11

   return (int *)(thru[__TPF_OPTOPT_ITUCOOPT]);                                 //ZTPF11
}                                                                               //ZTPF11


/* This function returns the address of the opterr variable */
static inline int *                                                             //ZTPF11
__attribute__ ((__unused__))                                                    //PJ45408
__tpf_opterr_location(void)                                                     //ZTPF11
{                                                                               //ZTPF11
   __tpf_thru_fields_t thru;                                                    //ZTPF11

   thru = __tpf_thread_unique_addr();                                           //ZTPF11

   return (int *)(thru[__TPF_OPTERR_ITUCOERR]);                                 //ZTPF11
}                                                                               //ZTPF11


#ifdef __cplusplus                                                              //ZTPF11
   }                                                                            //ZTPF11
#endif                                                                          //ZTPF11

#endif                                                                          //ZTPF11
